
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class EnrollmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const enrollments = await db.enrollments.create(
            {
                id: data.id || undefined,
        
        enrolled_at: data.enrolled_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await enrollments.setStudent( data.student || null, {
            transaction,
        });
        
        await enrollments.setClass_section( data.class_section || null, {
            transaction,
        });
        

        

        

        return enrollments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const enrollmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                enrolled_at: item.enrolled_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const enrollments = await db.enrollments.bulkCreate(enrollmentsData, { transaction });

        // For each item created, replace relation files
        

        return enrollments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const enrollments = await db.enrollments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.enrolled_at !== undefined) updatePayload.enrolled_at = data.enrolled_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await enrollments.update(updatePayload, {transaction});

        
        
        if (data.student !== undefined) {
            await enrollments.setStudent(
              
              data.student,
              
              { transaction }
            );
        }
        
        if (data.class_section !== undefined) {
            await enrollments.setClass_section(
              
              data.class_section,
              
              { transaction }
            );
        }
        

        
        

        

        return enrollments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const enrollments = await db.enrollments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of enrollments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of enrollments) {
                await record.destroy({transaction});
            }
        });


        return enrollments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const enrollments = await db.enrollments.findByPk(id, options);

        await enrollments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await enrollments.destroy({
            transaction
        });

        return enrollments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const enrollments = await db.enrollments.findOne(
            { where },
            { transaction },
        );

        if (!enrollments) {
            return enrollments;
        }

        const output = enrollments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.student = await enrollments.getStudent({
            transaction
        });
        
        
        output.class_section = await enrollments.getClass_section({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.students,
        as: 'student',
        
        where: filter.student ? {
          [Op.or]: [
            { id: { [Op.in]: filter.student.split('|').map(term => Utils.uuid(term)) } },
            {
              full_name: {
                [Op.or]: filter.student.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.class_sections,
        as: 'class_section',
        
        where: filter.class_section ? {
          [Op.or]: [
            { id: { [Op.in]: filter.class_section.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.class_section.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.enrolled_atRange) {
                const [start, end] = filter.enrolled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enrolled_at: {
                    ...where.enrolled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enrolled_at: {
                    ...where.enrolled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.enrollments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'enrollments',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.enrollments.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

